#!/usr/bin/perl

use strict;
use warnings;
use DBI;

my $file = "thread.rrd";
if ( !-f $file ) {
    system(
        "rrdtool",                    'create',
        $file,                        '--step',
        '60',                         'DS:cached:GAUGE:600:U:U',
        'DS:connected:GAUGE:600:U:U', 'DS:running:GAUGE:600:U:U',
        'RRA:AVERAGE:0.5:5:9216',     'RRA:AVERAGE:0.5:30:1536',
        'RRA:AVERAGE:0.5:120:768',    'RRA:AVERAGE:0.5:1440:794'
    );
}

my $dbh = DBI->connect("dbi:mysql:mysql:host=db-host1");
my %ret;
map { $ret{ $_->[0] } = $_->[1] }
  @{ $dbh->selectall_arrayref("SHOW GLOBAL STATUS") };

system(
    'rrdtool',
    'update', $file, '-t',
    'cached:connected:running',
    sprintf( "N:%d:%d:%d",
        $ret{Threads_cached}, $ret{Threads_connected},
        $ret{Threads_running} )
);

